Index: cpukit/posix/src/pspinlock.c
===================================================================
--- cpukit/posix/src/pspinlock.c	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/posix/src/pspinlock.c	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -20,6 +20,5 @@
 
 #include <rtems/posix/spinlockimpl.h>
-
-#include <errno.h>
+#include <rtems/posix/posixapi.h>
 
 int pthread_spin_lock( pthread_spinlock_t *spinlock )
@@ -27,5 +26,5 @@
   POSIX_Spinlock_Control *the_spinlock;
   ISR_lock_Context        lock_context;
-  CORE_spinlock_Status    status;
+  Status_Control          status;
 
   the_spinlock = _POSIX_Spinlock_Get( spinlock, &lock_context );
@@ -40,4 +39,4 @@
     &lock_context
   );
-  return _POSIX_Spinlock_Translate_core_spinlock_return_code( status );
+  return _POSIX_Get_error( status );
 }
Index: cpukit/posix/src/pspintrylock.c
===================================================================
--- cpukit/posix/src/pspintrylock.c	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/posix/src/pspintrylock.c	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -20,6 +20,5 @@
 
 #include <rtems/posix/spinlockimpl.h>
-
-#include <errno.h>
+#include <rtems/posix/posixapi.h>
 
 int pthread_spin_trylock( pthread_spinlock_t *spinlock )
@@ -27,5 +26,5 @@
   POSIX_Spinlock_Control *the_spinlock;
   ISR_lock_Context        lock_context;
-  CORE_spinlock_Status    status;
+  Status_Control          status;
 
   the_spinlock = _POSIX_Spinlock_Get( spinlock, &lock_context );
@@ -40,4 +39,4 @@
     &lock_context
   );
-  return _POSIX_Spinlock_Translate_core_spinlock_return_code( status );
+  return _POSIX_Get_error( status );
 }
Index: cpukit/posix/src/pspinunlock.c
===================================================================
--- cpukit/posix/src/pspinunlock.c	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/posix/src/pspinunlock.c	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -22,6 +22,5 @@
 
 #include <rtems/posix/spinlockimpl.h>
-
-#include <errno.h>
+#include <rtems/posix/posixapi.h>
 
 int pthread_spin_unlock( pthread_spinlock_t *spinlock )
@@ -29,5 +28,5 @@
   POSIX_Spinlock_Control *the_spinlock;
   ISR_lock_Context        lock_context;
-  CORE_spinlock_Status    status;
+  Status_Control          status;
 
   the_spinlock = _POSIX_Spinlock_Get( spinlock, &lock_context );
@@ -37,4 +36,4 @@
 
   status = _CORE_spinlock_Surrender( &the_spinlock->Spinlock, &lock_context );
-  return _POSIX_Spinlock_Translate_core_spinlock_return_code( status );
+  return _POSIX_Get_error( status );
 }
Index: cpukit/posix/src/pthreadjoin.c
===================================================================
--- cpukit/posix/src/pthreadjoin.c	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/posix/src/pthreadjoin.c	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -27,4 +27,5 @@
 
 #include <rtems/posix/threadsup.h>
+#include <rtems/posix/posixapi.h>
 #include <rtems/score/threadimpl.h>
 #include <rtems/score/statesimpl.h>
@@ -73,6 +74,6 @@
     );
 
-    if ( executing->Wait.return_code != 0 ) {
-      _Assert( executing->Wait.return_code == EINTR );
+    if ( _POSIX_Get_error_after_wait( executing ) != 0 ) {
+      _Assert( _POSIX_Get_error_after_wait( executing ) == EINTR );
       return EINTR;
     }
Index: cpukit/posix/src/semaphorewaitsupp.c
===================================================================
--- cpukit/posix/src/semaphorewaitsupp.c	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/posix/src/semaphorewaitsupp.c	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -22,4 +22,5 @@
 
 #include <rtems/posix/semaphoreimpl.h>
+#include <rtems/posix/posixapi.h>
 
 THREAD_QUEUE_OBJECT_ASSERT( POSIX_Semaphore_Control, Semaphore.Wait_queue );
@@ -32,6 +33,6 @@
 {
   POSIX_Semaphore_Control *the_semaphore;
-  Thread_Control          *executing;
   Thread_queue_Context     queue_context;
+  Status_Control           status;
 
   the_semaphore = _POSIX_Semaphore_Get( sem, &queue_context );
@@ -41,22 +42,11 @@
   }
 
-  executing = _Thread_Executing;
-
-  _CORE_semaphore_Seize(
+  status = _CORE_semaphore_Seize(
     &the_semaphore->Semaphore,
-    executing,
+    _Thread_Executing,
     blocking,
     timeout,
     &queue_context
   );
-
-  if ( executing->Wait.return_code == CORE_SEMAPHORE_STATUS_SUCCESSFUL ) {
-    return 0;
-  }
-
-  rtems_set_errno_and_return_minus_one(
-    _POSIX_Semaphore_Translate_core_semaphore_return_code(
-      executing->Wait.return_code
-    )
-  );
+  return _POSIX_Zero_or_minus_one_plus_errno( status );
 }
Index: cpukit/posix/src/sempost.c
===================================================================
--- cpukit/posix/src/sempost.c	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/posix/src/sempost.c	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -23,4 +23,5 @@
 
 #include <rtems/posix/semaphoreimpl.h>
+#include <rtems/posix/posixapi.h>
 
 int sem_post(
@@ -30,5 +31,5 @@
   POSIX_Semaphore_Control *the_semaphore;
   Thread_queue_Context     queue_context;
-  CORE_semaphore_Status    status;
+  Status_Control           status;
 
   the_semaphore = _POSIX_Semaphore_Get( sem, &queue_context );
@@ -43,11 +44,4 @@
     &queue_context
   );
-
-  if ( status == CORE_SEMAPHORE_STATUS_SUCCESSFUL ) {
-    return 0;
-  }
-
-  rtems_set_errno_and_return_minus_one(
-    _POSIX_Semaphore_Translate_core_semaphore_return_code( status )
-  );
+  return _POSIX_Zero_or_minus_one_plus_errno( status );
 }
Index: cpukit/posix/src/sigtimedwait.c
===================================================================
--- cpukit/posix/src/sigtimedwait.c	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/posix/src/sigtimedwait.c	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -19,12 +19,10 @@
 #endif
 
-#include <pthread.h>
 #include <signal.h>
-#include <errno.h>
 
 #include <rtems/posix/pthreadimpl.h>
 #include <rtems/posix/psignalimpl.h>
+#include <rtems/posix/posixapi.h>
 #include <rtems/score/threadqimpl.h>
-#include <rtems/seterr.h>
 #include <rtems/score/isr.h>
 
@@ -79,4 +77,5 @@
   int                signo;
   ISR_lock_Context   lock_context;
+  int                error;
 
   /*
@@ -151,5 +150,4 @@
   the_info->si_signo = -1;
 
-  executing->Wait.return_code     = EINTR;
   executing->Wait.option          = *set;
   executing->Wait.return_argument = the_info;
@@ -160,5 +158,4 @@
     STATES_WAITING_FOR_SIGNAL | STATES_INTERRUPTIBLE_BY_SIGNAL,
     interval,
-    EAGAIN,
     &lock_context
   );
@@ -183,8 +180,15 @@
    */
 
-  if ( (executing->Wait.return_code != EINTR)
-       || !(*set & signo_to_mask( the_info->si_signo )) ) {
-    errno = executing->Wait.return_code;
-    return -1;
+  error = _POSIX_Get_error_after_wait( executing );
+
+  if (
+    error != EINTR
+     || ( *set & signo_to_mask( the_info->si_signo ) ) == 0
+  ) {
+    if ( error == ETIMEDOUT ) {
+      error = EAGAIN;
+    }
+
+    rtems_set_errno_and_return_minus_one( error );
   }
 
Index: cpukit/rtems/Makefile.am
===================================================================
--- cpukit/rtems/Makefile.am	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/rtems/Makefile.am	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -130,5 +130,4 @@
 librtems_a_SOURCES += src/barrierdelete.c
 librtems_a_SOURCES += src/barrierident.c
-librtems_a_SOURCES += src/barriertranslatereturncode.c
 librtems_a_SOURCES += src/barrierrelease.c
 librtems_a_SOURCES += src/barrierwait.c
@@ -171,5 +170,4 @@
 librtems_a_SOURCES += src/msgqreceive.c
 librtems_a_SOURCES += src/msgqsend.c
-librtems_a_SOURCES += src/msgqtranslatereturncode.c
 librtems_a_SOURCES += src/msgqurgent.c
 
@@ -182,5 +180,4 @@
 librtems_a_SOURCES += src/semrelease.c
 librtems_a_SOURCES += src/semflush.c
-librtems_a_SOURCES += src/semtranslatereturncode.c
 librtems_a_SOURCES += src/semsetpriority.c
 
Index: cpukit/rtems/include/rtems/rtems/barrierimpl.h
===================================================================
--- cpukit/rtems/include/rtems/rtems/barrierimpl.h	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/rtems/include/rtems/rtems/barrierimpl.h	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -80,18 +80,4 @@
 }
 
-/**
- * @brief Translate SuperCore Barrier Status Code to RTEMS Status Code
- *
- * This function returns a RTEMS status code based on the barrier
- * status code specified.
- *
- * @param[in] the_status is the SuperCore Barrier status to translate.
- *
- * @retval a status code indicating success or the reason for failure.
- */
-rtems_status_code _Barrier_Translate_core_barrier_return_code (
-  CORE_barrier_Status  the_status
-);
-
 /**@}*/
 
Index: cpukit/rtems/include/rtems/rtems/eventimpl.h
===================================================================
--- cpukit/rtems/include/rtems/rtems/eventimpl.h	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/rtems/include/rtems/rtems/eventimpl.h	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -45,5 +45,5 @@
 #define EVENT_SETS_NONE_PENDING 0
 
-void _Event_Seize(
+rtems_status_code _Event_Seize(
   rtems_event_set    event_in,
   rtems_option       option_set,
Index: cpukit/rtems/include/rtems/rtems/messageimpl.h
===================================================================
--- cpukit/rtems/include/rtems/rtems/messageimpl.h	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/rtems/include/rtems/rtems/messageimpl.h	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -75,18 +75,4 @@
 
 /**
- * @brief Message queue Translate Core Message Queue Return Code
- *
- * This function returns a RTEMS status code based on
- * @a the_message_queue_status.
- *
- * @param[in] the_message_queue_status is the status code to translate
- *
- * @retval translated RTEMS status code
- */
-rtems_status_code _Message_queue_Translate_core_message_queue_return_code (
-  uint32_t   the_message_queue_status
-);
-
-/**
  *  @brief Deallocates a message queue control block into
  *  the inactive chain of free message queue control blocks.
Index: cpukit/rtems/include/rtems/rtems/semimpl.h
===================================================================
--- cpukit/rtems/include/rtems/rtems/semimpl.h	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/rtems/include/rtems/rtems/semimpl.h	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -32,80 +32,4 @@
  */
 extern Objects_Information _Semaphore_Information;
-
-extern const rtems_status_code
-  _Semaphore_Translate_core_mutex_return_code_[];
-
-extern const rtems_status_code
-  _Semaphore_Translate_core_semaphore_return_code_[];
-
-/**
- * @brief Semaphore Translate Core Mutex Return Code
- *
- * This function returns a RTEMS status code based on the mutex
- * status code specified.
- *
- * @param[in] status is the mutex status code to translate
- *
- * @retval translated RTEMS status code
- */
-RTEMS_INLINE_ROUTINE rtems_status_code
-_Semaphore_Translate_core_mutex_return_code(
-  uint32_t   status
-)
-{
-  /*
-   *  If this thread is blocking waiting for a result on a remote operation.
-   */
-  #if defined(RTEMS_MULTIPROCESSING)
-    if ( _Thread_Is_proxy_blocking(status) )
-      return RTEMS_PROXY_BLOCKING;
-  #endif
-
-  /*
-   *  Internal consistency check for bad status from SuperCore
-   */
-  #if defined(RTEMS_DEBUG)
-    if ( status > CORE_MUTEX_STATUS_LAST )
-      return RTEMS_INTERNAL_ERROR;
-  #endif
-  return _Semaphore_Translate_core_mutex_return_code_[status];
-}
-
-#if defined(RTEMS_SMP)
-RTEMS_INLINE_ROUTINE rtems_status_code
-_Semaphore_Translate_MRSP_status_code( MRSP_Status mrsp_status )
-{
-  return (rtems_status_code) mrsp_status;
-}
-#endif
-
-/**
- * @brief Semaphore Translate Core Semaphore Return Code
- *
- * This function returns a RTEMS status code based on the semaphore
- * status code specified.
- *
- * @param[in] status is the semaphore status code to translate
- *
- * @retval translated RTEMS status code
- */
-RTEMS_INLINE_ROUTINE rtems_status_code
-_Semaphore_Translate_core_semaphore_return_code(
-  uint32_t   status
-)
-{
-  #if defined(RTEMS_MULTIPROCESSING)
-    if ( _Thread_Is_proxy_blocking(status) )
-      return RTEMS_PROXY_BLOCKING;
-  #endif
-  /*
-   *  Internal consistency check for bad status from SuperCore
-   */
-  #if defined(RTEMS_DEBUG)
-    if ( status > CORE_SEMAPHORE_STATUS_LAST )
-      return RTEMS_INTERNAL_ERROR;
-  #endif
-  return _Semaphore_Translate_core_semaphore_return_code_[status];
-}
 
 /**
Index: cpukit/rtems/include/rtems/rtems/statusimpl.h
===================================================================
--- cpukit/rtems/include/rtems/rtems/statusimpl.h	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/rtems/include/rtems/rtems/statusimpl.h	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -19,4 +19,5 @@
 
 #include <rtems/rtems/status.h>
+#include <rtems/score/threadimpl.h>
 
 #ifdef __cplusplus
@@ -40,4 +41,18 @@
 extern const rtems_status_code _Status_Object_name_errors_to_status[];
 
+RTEMS_INLINE_ROUTINE rtems_status_code _Status_Get(
+  Status_Control status
+)
+{
+  return (rtems_status_code) STATUS_GET_CLASSIC( status );
+}
+
+RTEMS_INLINE_ROUTINE rtems_status_code _Status_Get_after_wait(
+  const Thread_Control *executing
+)
+{
+  return _Status_Get( _Thread_Wait_get_status( executing ) );
+}
+
 /**@}*/
 
Index: cpukit/rtems/src/barrierwait.c
===================================================================
--- cpukit/rtems/src/barrierwait.c	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/rtems/src/barrierwait.c	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -20,4 +20,5 @@
 
 #include <rtems/rtems/barrierimpl.h>
+#include <rtems/rtems/statusimpl.h>
 
 THREAD_QUEUE_OBJECT_ASSERT( Barrier_Control, Barrier.Wait_queue );
@@ -30,5 +31,5 @@
   Barrier_Control      *the_barrier;
   Thread_queue_Context  queue_context;
-  Thread_Control       *executing;
+  Status_Control        status;
 
   the_barrier = _Barrier_Get( id, &queue_context );
@@ -38,14 +39,11 @@
   }
 
-  executing = _Thread_Executing;
-  _CORE_barrier_Seize(
+  status = _CORE_barrier_Seize(
     &the_barrier->Barrier,
-    executing,
+    _Thread_Executing,
     true,
     timeout,
     &queue_context
   );
-  return _Barrier_Translate_core_barrier_return_code(
-    executing->Wait.return_code
-  );
+  return _Status_Get( status );
 }
Index: cpukit/rtems/src/eventmp.c
===================================================================
--- cpukit/rtems/src/eventmp.c	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/rtems/src/eventmp.c	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -20,4 +20,5 @@
 
 #include <rtems/rtems/eventimpl.h>
+#include <rtems/rtems/statusimpl.h>
 #include <rtems/score/threadimpl.h>
 #include <rtems/score/statesimpl.h>
@@ -62,4 +63,5 @@
 {
   Event_MP_Packet *the_packet;
+  Status_Control   status;
 
   the_packet = _Event_MP_Get_packet( id );
@@ -75,10 +77,10 @@
   the_packet->event_in          = event_in;
 
-  return (rtems_status_code) _MPCI_Send_request_packet(
+  status = _MPCI_Send_request_packet(
     _Objects_Get_node( id ),
     &the_packet->Prefix,
-    STATES_READY,
-    RTEMS_TIMEOUT
+    STATES_READY
   );
+  return _Status_Get( status );
 }
 
Index: cpukit/rtems/src/eventreceive.c
===================================================================
--- cpukit/rtems/src/eventreceive.c	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/rtems/src/eventreceive.c	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -44,5 +44,5 @@
 
     if ( !_Event_sets_Is_empty( event_in ) ) {
-      _Event_Seize(
+      sc = _Event_Seize(
         event_in,
         option_set,
@@ -55,6 +55,4 @@
         &lock_context
       );
-
-      sc = executing->Wait.return_code;
     } else {
       *event_out = event->pending_events;
Index: cpukit/rtems/src/eventseize.c
===================================================================
--- cpukit/rtems/src/eventseize.c	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/rtems/src/eventseize.c	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -22,15 +22,9 @@
 #include <rtems/rtems/eventimpl.h>
 #include <rtems/rtems/optionsimpl.h>
+#include <rtems/rtems/statusimpl.h>
 #include <rtems/score/threadimpl.h>
 #include <rtems/score/watchdogimpl.h>
 
-/*
- *  INTERRUPT LATENCY:
- *    available
- *    wait
- *    check sync
- */
-
-void _Event_Seize(
+rtems_status_code _Event_Seize(
   rtems_event_set    event_in,
   rtems_option       option_set,
@@ -50,6 +44,4 @@
   Per_CPU_Control   *cpu_self;
 
-  executing->Wait.return_code = RTEMS_SUCCESSFUL;
-
   pending_events = event->pending_events;
   seized_events  = _Event_sets_Get( pending_events, event_in );
@@ -61,12 +53,11 @@
     _Thread_Lock_release_default( executing, lock_context );
     *event_out = seized_events;
-    return;
+    return RTEMS_SUCCESSFUL;
   }
 
   if ( _Options_Is_no_wait( option_set ) ) {
     _Thread_Lock_release_default( executing, lock_context );
-    executing->Wait.return_code = RTEMS_UNSATISFIED;
     *event_out = seized_events;
-    return;
+    return RTEMS_UNSATISFIED;
   }
 
@@ -81,4 +72,5 @@
    *        issue but better safe than sorry.
    */
+  executing->Wait.return_code     = STATUS_SUCCESSFUL;
   executing->Wait.option          = option_set;
   executing->Wait.count           = event_in;
@@ -90,5 +82,4 @@
 
   if ( ticks ) {
-    _Thread_Wait_set_timeout_code( executing, RTEMS_TIMEOUT );
     _Thread_Timer_insert_relative(
       executing,
@@ -118,4 +109,5 @@
 
   _Thread_Dispatch_enable( cpu_self );
+  return _Status_Get_after_wait( executing );
 }
 
Index: cpukit/rtems/src/msgmp.c
===================================================================
--- cpukit/rtems/src/msgmp.c	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/rtems/src/msgmp.c	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -21,4 +21,5 @@
 #include <rtems/rtems/messageimpl.h>
 #include <rtems/rtems/optionsimpl.h>
+#include <rtems/rtems/statusimpl.h>
 #include <rtems/score/coremsgimpl.h>
 #include <rtems/score/statesimpl.h>
@@ -106,4 +107,5 @@
 {
   Message_queue_MP_Packet *the_packet;
+  Status_Control           status;
 
   if ( !_Message_queue_MP_Is_remote( message_queue_id ) ) {
@@ -156,11 +158,10 @@
       }
 
-      return (rtems_status_code) _MPCI_Send_request_packet(
+      status = _MPCI_Send_request_packet(
         _Objects_Get_node(message_queue_id),
         &the_packet->Prefix,
-        STATES_WAITING_FOR_MESSAGE,
-        RTEMS_TIMEOUT
-      );
-      break;
+        STATES_WAITING_FOR_MESSAGE
+      );
+      return _Status_Get( status );
 
     case MESSAGE_QUEUE_MP_RECEIVE_REQUEST:
@@ -182,11 +183,10 @@
       _Thread_Executing->Wait.return_argument = size_p;
 
-      return (rtems_status_code) _MPCI_Send_request_packet(
+      status = _MPCI_Send_request_packet(
         _Objects_Get_node(message_queue_id),
         &the_packet->Prefix,
-        STATES_WAITING_FOR_MESSAGE,
-        RTEMS_TIMEOUT
-      );
-      break;
+        STATES_WAITING_FOR_MESSAGE
+      );
+      return _Status_Get( status );
 
     case MESSAGE_QUEUE_MP_ANNOUNCE_CREATE:
Index: cpukit/rtems/src/msgqbroadcast.c
===================================================================
--- cpukit/rtems/src/msgqbroadcast.c	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/rtems/src/msgqbroadcast.c	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -20,4 +20,5 @@
 
 #include <rtems/rtems/messageimpl.h>
+#include <rtems/rtems/statusimpl.h>
 
 rtems_status_code rtems_message_queue_broadcast(
@@ -28,7 +29,7 @@
 )
 {
-  Message_queue_Control     *the_message_queue;
-  Thread_queue_Context       queue_context;
-  CORE_message_queue_Status  status;
+  Message_queue_Control *the_message_queue;
+  Thread_queue_Context   queue_context;
+  Status_Control         status;
 
   if ( buffer == NULL ) {
@@ -61,4 +62,4 @@
     &queue_context
   );
-  return _Message_queue_Translate_core_message_queue_return_code( status );
+  return _Status_Get( status );
 }
Index: cpukit/rtems/src/msgqreceive.c
===================================================================
--- cpukit/rtems/src/msgqreceive.c	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/rtems/src/msgqreceive.c	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -21,4 +21,5 @@
 #include <rtems/rtems/messageimpl.h>
 #include <rtems/rtems/optionsimpl.h>
+#include <rtems/rtems/statusimpl.h>
 
 THREAD_QUEUE_OBJECT_ASSERT( Message_queue_Control, message_queue.Wait_queue );
@@ -35,4 +36,5 @@
   Thread_queue_Context   queue_context;
   Thread_Control        *executing;
+  Status_Control         status;
 
   if ( buffer == NULL ) {
@@ -60,5 +62,5 @@
 
   executing = _Thread_Executing;
-  _CORE_message_queue_Seize(
+  status = _CORE_message_queue_Seize(
     &the_message_queue->message_queue,
     executing,
@@ -69,6 +71,4 @@
     &queue_context
   );
-  return _Message_queue_Translate_core_message_queue_return_code(
-    executing->Wait.return_code
-  );
+  return _Status_Get( status );
 }
Index: cpukit/rtems/src/msgqsend.c
===================================================================
--- cpukit/rtems/src/msgqsend.c	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/rtems/src/msgqsend.c	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -20,4 +20,5 @@
 
 #include <rtems/rtems/messageimpl.h>
+#include <rtems/rtems/statusimpl.h>
 
 rtems_status_code rtems_message_queue_send(
@@ -27,7 +28,7 @@
 )
 {
-  Message_queue_Control     *the_message_queue;
-  Thread_queue_Context       queue_context;
-  CORE_message_queue_Status  status;
+  Message_queue_Control *the_message_queue;
+  Thread_queue_Context   queue_context;
+  Status_Control         status;
 
   if ( buffer == NULL ) {
@@ -61,10 +62,4 @@
     &queue_context
   );
-
-  /*
-   *  Since this API does not allow for blocking sends, we can directly
-   *  return the returned status.
-   */
-
-  return _Message_queue_Translate_core_message_queue_return_code( status );
+  return _Status_Get( status );
 }
Index: cpukit/rtems/src/msgqurgent.c
===================================================================
--- cpukit/rtems/src/msgqurgent.c	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/rtems/src/msgqurgent.c	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -20,4 +20,5 @@
 
 #include <rtems/rtems/messageimpl.h>
+#include <rtems/rtems/statusimpl.h>
 
 rtems_status_code rtems_message_queue_urgent(
@@ -27,7 +28,7 @@
 )
 {
-  Message_queue_Control     *the_message_queue;
-  Thread_queue_Context       queue_context;
-  CORE_message_queue_Status  status;
+  Message_queue_Control *the_message_queue;
+  Thread_queue_Context   queue_context;
+  Status_Control         status;
 
   if ( buffer == NULL ) {
@@ -61,10 +62,4 @@
     &queue_context
   );
-
-  /*
-   *  Since this API does not allow for blocking sends, we can directly
-   *  return the returned status.
-   */
-
-  return _Message_queue_Translate_core_message_queue_return_code( status );
+  return _Status_Get( status );
 }
Index: cpukit/rtems/src/partmp.c
===================================================================
--- cpukit/rtems/src/partmp.c	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/rtems/src/partmp.c	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -20,4 +20,5 @@
 
 #include <rtems/rtems/partimpl.h>
+#include <rtems/rtems/statusimpl.h>
 #include <rtems/score/statesimpl.h>
 #include <rtems/score/threadimpl.h>
@@ -101,4 +102,5 @@
 {
   Partition_MP_Packet *the_packet;
+  Status_Control       status;
 
   if ( !_Partition_MP_Is_remote( partition_id ) ) {
@@ -115,13 +117,10 @@
       the_packet->buffer = buffer;
 
-      return
-        _MPCI_Send_request_packet(
-          _Objects_Get_node( partition_id ),
-          &the_packet->Prefix,
-          STATES_READY,     /* Not used */
-          RTEMS_TIMEOUT
-        );
-
-      break;
+      status = _MPCI_Send_request_packet(
+        _Objects_Get_node( partition_id ),
+        &the_packet->Prefix,
+        STATES_READY /* Not used */
+      );
+      return _Status_Get( status );
 
     case PARTITION_MP_ANNOUNCE_CREATE:
Index: cpukit/rtems/src/regiongetsegment.c
===================================================================
--- cpukit/rtems/src/regiongetsegment.c	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/rtems/src/regiongetsegment.c	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -21,4 +21,5 @@
 #include <rtems/rtems/regionimpl.h>
 #include <rtems/rtems/optionsimpl.h>
+#include <rtems/rtems/statusimpl.h>
 #include <rtems/score/threadqimpl.h>
 #include <rtems/score/statesimpl.h>
@@ -86,11 +87,10 @@
         executing,
         STATES_WAITING_FOR_SEGMENT,
-        timeout,
-        RTEMS_TIMEOUT
+        timeout
       );
 
       _Thread_Dispatch_enable( cpu_self );
 
-      return (rtems_status_code) executing->Wait.return_code;
+      return _Status_Get_after_wait( executing );
     }
   }
Index: cpukit/rtems/src/regionprocessqueue.c
===================================================================
--- cpukit/rtems/src/regionprocessqueue.c	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/rtems/src/regionprocessqueue.c	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -20,4 +20,5 @@
 
 #include <rtems/rtems/regionimpl.h>
+#include <rtems/score/status.h>
 #include <rtems/score/threadqimpl.h>
 
@@ -66,5 +67,5 @@
     *(void **)the_thread->Wait.return_argument = the_segment;
     _Thread_queue_Extract( the_thread );
-    the_thread->Wait.return_code = RTEMS_SUCCESSFUL;
+    the_thread->Wait.return_code = STATUS_SUCCESSFUL;
   }
 
Index: cpukit/rtems/src/semcreate.c
===================================================================
--- cpukit/rtems/src/semcreate.c	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/rtems/src/semcreate.c	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -26,4 +26,5 @@
 #include <rtems/rtems/options.h>
 #include <rtems/rtems/semimpl.h>
+#include <rtems/rtems/statusimpl.h>
 #include <rtems/rtems/tasksimpl.h>
 #include <rtems/score/coremuteximpl.h>
@@ -64,5 +65,5 @@
   CORE_mutex_Attributes       the_mutex_attr;
   CORE_semaphore_Disciplines  semaphore_discipline;
-  CORE_mutex_Status           mutex_status;
+  Status_Control              status;
 
   if ( !rtems_is_name_valid( name ) )
@@ -156,7 +157,8 @@
       count
     );
+    status = STATUS_SUCCESSFUL;
 #if defined(RTEMS_SMP)
   } else if ( _Attributes_Is_multiprocessor_resource_sharing( attribute_set ) ) {
-    MRSP_Status mrsp_status = _MRSP_Initialize(
+    status = _MRSP_Initialize(
       &the_semaphore->Core_control.mrsp,
       priority_ceiling,
@@ -164,11 +166,4 @@
       count != 1
     );
-
-    if ( mrsp_status != MRSP_SUCCESSFUL ) {
-      _Semaphore_Free( the_semaphore );
-      _Objects_Allocator_unlock();
-
-      return _Semaphore_Translate_MRSP_status_code( mrsp_status );
-    }
 #endif
   } else {
@@ -203,5 +198,5 @@
     }
 
-    mutex_status = _CORE_mutex_Initialize(
+    status = _CORE_mutex_Initialize(
       &the_semaphore->Core_control.mutex,
       _Thread_Get_executing(),
@@ -209,10 +204,10 @@
       count != 1
     );
-
-    if ( mutex_status == CORE_MUTEX_STATUS_CEILING_VIOLATED ) {
-      _Semaphore_Free( the_semaphore );
-      _Objects_Allocator_unlock();
-      return RTEMS_INVALID_PRIORITY;
-    }
+  }
+
+  if ( status != STATUS_SUCCESSFUL ) {
+    _Semaphore_Free( the_semaphore );
+    _Objects_Allocator_unlock();
+    return _Status_Get( status );
   }
 
Index: cpukit/rtems/src/semdelete.c
===================================================================
--- cpukit/rtems/src/semdelete.c	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/rtems/src/semdelete.c	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -21,4 +21,5 @@
 #include <rtems/rtems/semimpl.h>
 #include <rtems/rtems/attrimpl.h>
+#include <rtems/rtems/statusimpl.h>
 
 rtems_status_code rtems_semaphore_delete(
@@ -53,5 +54,5 @@
 #if defined(RTEMS_SMP)
   if ( _Attributes_Is_multiprocessor_resource_sharing( attribute_set ) ) {
-    MRSP_Status mrsp_status;
+    Status_Control status;
 
     _MRSP_Acquire_critical(
@@ -59,6 +60,6 @@
       &queue_context
     );
-    mrsp_status = _MRSP_Can_destroy( &the_semaphore->Core_control.mrsp );
-    if ( mrsp_status != MRSP_SUCCESSFUL ) {
+    status = _MRSP_Can_destroy( &the_semaphore->Core_control.mrsp );
+    if ( status != STATUS_SUCCESSFUL ) {
       _MRSP_Release(
         &the_semaphore->Core_control.mrsp,
@@ -66,5 +67,5 @@
       );
       _Objects_Allocator_unlock();
-      return _Semaphore_Translate_MRSP_status_code( mrsp_status );
+      return _Status_Get( status );
     }
   } else
@@ -104,5 +105,5 @@
     _CORE_mutex_Flush(
       &the_semaphore->Core_control.mutex,
-      _CORE_mutex_Was_deleted,
+      _Thread_queue_Flush_status_object_was_deleted,
       &queue_context
     );
Index: cpukit/rtems/src/semflush.c
===================================================================
--- cpukit/rtems/src/semflush.c	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/rtems/src/semflush.c	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -59,5 +59,5 @@
     _CORE_mutex_Flush(
       &the_semaphore->Core_control.mutex,
-      _CORE_mutex_Unsatisfied_nowait,
+      _Thread_queue_Flush_status_unavailable,
       &queue_context
     );
Index: cpukit/rtems/src/semmp.c
===================================================================
--- cpukit/rtems/src/semmp.c	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/rtems/src/semmp.c	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -21,4 +21,5 @@
 #include <rtems/rtems/semimpl.h>
 #include <rtems/rtems/optionsimpl.h>
+#include <rtems/rtems/statusimpl.h>
 
 RTEMS_STATIC_ASSERT(
@@ -81,4 +82,5 @@
 {
   Semaphore_MP_Packet *the_packet;
+  Status_Control       status;
 
   switch ( operation ) {
@@ -98,11 +100,10 @@
       the_packet->option_set        = option_set;
 
-      return _MPCI_Send_request_packet(
-          _Objects_Get_node( semaphore_id ),
-          &the_packet->Prefix,
-          STATES_WAITING_FOR_SEMAPHORE,
-          RTEMS_TIMEOUT
-        );
-      break;
+      status = _MPCI_Send_request_packet(
+        _Objects_Get_node( semaphore_id ),
+        &the_packet->Prefix,
+        STATES_WAITING_FOR_SEMAPHORE
+      );
+      return _Status_Get( status );
 
     case SEMAPHORE_MP_ANNOUNCE_CREATE:
